package candidates;

use strict;

sub includeCandidate
{
    my $filler_candidates = $_[0];
    my $candidate = $_[1];

    push @{ $filler_candidates }, $candidate;

    return $filler_candidates;
}


sub nearContext
{
    my $context = $_[0];
    my $document = $_[1];
    my $sentence_target = $_[2];
    my $token_target = $_[3];
    
    my $window = 2;
    my $first_sentence = $sentence_target - $window;
    if ($first_sentence < 0)
    {
	$first_sentence = 0;
    }

    for (my $i=$sentence_target; $i>=$first_sentence; $i--)
    {

	my @tokens = sort {$a <=> $b} keys %{ $document->{$i}->{tokens} };

	if ($i == $sentence_target)
	{
	    my $in_sentence_left=1;
	    my $in_sentence_right=1;
	    my $displacement=1;

	    while ($in_sentence_left || $in_sentence_right)
	    {
		my $left_position = $token_target - $displacement;
		my $right_position = $token_target + $displacement;
		
		if ($left_position < 1)
		{
		    $in_sentence_left = 0;
		}
		else
		{
		    my $candidate;
		    $candidate->{sentence} = $i;
		    $candidate->{token} = $left_position;
		    $candidate->{salience} = salience::candidateSalience($candidate,$sentence_target,$document);
		    $candidate->{relative_salience} = $candidate->{salience};
		    $context = includeCandidate($context,$candidate);
		}

		if ($right_position > $#tokens)
		{
		    $in_sentence_right = 0;
		}
		else
		{
		    my $candidate;
		    $candidate->{sentence} = $i;
		    $candidate->{token} = $right_position;
		    $candidate->{salience} = salience::candidateSalience($candidate,$sentence_target,$document);
		    $candidate->{relative_salience} = $candidate->{salience};
		    $context = includeCandidate($context,$candidate);
		}

		$displacement++;
	    }
	}
	else
	{
	    for (my $j=$#tokens;$j>=1;$j--)
	    {
		my $candidate;
		$candidate->{sentence} = $i;
		$candidate->{token} = $j;
		$candidate->{salience} = salience::candidateSalience($candidate,$sentence_target,$document);
		$candidate->{relative_salience} = $candidate->{salience};
		$context = includeCandidate($context,$candidate);
	    }
	}
    }
    
    return $context;
}

1;
