package document;

use strict;

sub getDocumentStructure
{
    my $closedfile = $_[0];
    my $openfile = $_[1];

    my $document;

    my $sentence_idx = 0;
    my $predicate_idx = 0;
    
    open(CLOSED,$closedfile);
    while(my $line=<CLOSED>)
    {
	chop $line;

	if ($line eq "")
	{
	    $sentence_idx++;
	    $predicate_idx = 0;
	}
	else
	{
	    my @fields=split(/\t/,$line);
	
	    my $token_idx = $fields[0];
	    
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{form} = $fields[1];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{lemma} = $fields[2];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{plemma} = $fields[3];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{pos} = $fields[4];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{ppos} = $fields[5];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{feat} = $fields[6];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{pfeat} = $fields[7];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{head} = $fields[8];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{phead} = $fields[9];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{deprel} = $fields[10];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{pdeprel} = $fields[11];
	    
	    if ($fields[12] eq "Y")
	    {
		$document->{$sentence_idx}->{predicates}->{$predicate_idx}->{token_idx} = $fields[0];
		$document->{$sentence_idx}->{predicates}->{$predicate_idx}->{predicate} = $fields[13];
		$predicate_idx++;
	    }

	    for (my $i=14; $i<=$#fields; $i++)
	    {
		if ($fields[$i] ne "_")
		{
		    my $predicate_ref = $i - 14;
		    $document->{$sentence_idx}->{predicates}->{$predicate_ref}->{explicit_arg}->{$fields[$i]}->{token} = $fields[0];
		}
	    }
	}
    }
    close(CLOSED);

    $sentence_idx = 0;
    my $token_idx = 1;

    open(OPEN,$openfile);
    while(my $line=<OPEN>)
    {
	chop $line;

	if ($line eq "")
	{
	    $sentence_idx++;
	    $token_idx = 1;
	}
	else
	{
	    my @fields=split(/\t/,$line);

	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{name_entity} = $fields[3];
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{super_sense} = $fields[4];
	    $token_idx++;
	}
    }
    close(OPEN);

    return $document;
}


sub collapseDependencies
{
    my $document = $_[0];
   
    foreach my $sentence_idx (keys %{ $document })
    {
	foreach my $token_idx (keys %{ $document->{$sentence_idx}->{tokens} })
	{
	    my $deprel = $document->{$sentence_idx}->{tokens}->{$token_idx}->{pdeprel};
	    my $collapsed_deprel = $deprel;
	    my $head = $token_idx;

	    while ($collapsed_deprel=~/MOD/ || $collapsed_deprel=~/NAME/ || $collapsed_deprel=~/CONJ/ || $collapsed_deprel=~/COORD/ || $collapsed_deprel=~/TITLE/)
	    {
		$head = $document->{$sentence_idx}->{tokens}->{$head}->{phead};
		$collapsed_deprel = $document->{$sentence_idx}->{tokens}->{$head}->{pdeprel};
	    }
		
	    $document->{$sentence_idx}->{tokens}->{$token_idx}->{collapsed_deprel} = $collapsed_deprel;
	}
    }

    return $document;
}

1;
