package normalization;

use strict;

sub getNormalForms
{
    my $normalization;

    open(NORMAL,"data/pred-normalizations.file");
    while (my $line=<NORMAL>)
    {
	chop $line;
	my ($form, $normal) = split(/ /,$line);
	$normalization->{$form} = $normal;
    }
    close(NORMAL);

    return $normalization;
}


sub normalizePredicates
{
    my $document = $_[0];
    my $normalization = $_[1];

    foreach my $sentence_idx (keys %{ $document })
    {
	foreach my $predicate_idx (keys %{ $document->{$sentence_idx}->{predicates} })
	{
	    my $predicate = $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{predicate};
	    my $normal_form = $predicate;
	    if ($normalization->{$predicate} ne "")
	    {
		$normal_form = $normalization->{$predicate};
	    }
	    $document->{$sentence_idx}->{predicates}->{$predicate_idx}->{normalization} = $normal_form;
	}
    }

    return $document;
}


1;
