package span;

use strict;


sub properSpan
{
    my $token = $_[0];
    my $sentence = $_[1];

    my $span = "";

    my $search_token = $token;
    my $search_pos = $sentence->{tokens}->{$search_token}->{ppos};

    my $last_head;
    while (not($search_pos=~/^NN/) && not($search_pos=~/^CD/) && not($search_pos=~/^\$/) && $search_token ne $last_head)
    {
	$last_head = $search_token;
	my $head_found = 0;
	my $index = 1;
	while (not($head_found) && exists $sentence->{tokens}->{$index})
	{
	    if ($sentence->{tokens}->{$index}->{phead} == $search_token)
	    {
		$search_token = $index;
		$head_found = 1;
	    }
	    else
	    {
		$index++;
	    }
	}
       
	$search_pos = $sentence->{tokens}->{$search_token}->{ppos};
    }

    if ($search_token eq "")
    {
	$search_token = $token;
    }

    my $in_segment = 0;
    my $temp_segment = "";
    foreach my $sentence_token (sort {$a <=> $b} keys %{ $sentence->{tokens} })
    {
	my $sentence_token_head = $sentence->{tokens}->{$sentence_token}->{phead};
	
	if ($in_segment)
	{
	    if ($temp_segment eq "")
	    {
		$temp_segment = $sentence_token;
	    }
	    else
	    {
		$temp_segment = $temp_segment." ".$sentence_token;
	    }
	}

	
	if ($sentence_token == $search_token || $sentence_token_head == $search_token)
	{
	    if (not $in_segment)
	    {
		$temp_segment = $sentence_token;
		$in_segment = 1;
	    }

	    if ($span eq "")
	    {
		$span = $temp_segment;
		$temp_segment = "";
	    }
	    else
	    {
		$span = $span." ".$temp_segment;
		$temp_segment = "";
	    }
	}
    }
    
    return $span;
}






sub spanN
{
    my $token = $_[0];
    my $sentence = $_[1];
    
    my $span = $token;
    
    my $pursue = 0;
    my $ant_token = $token - 1;

    if ($sentence->{tokens}->{$ant_token}->{ppos}=~/^N/)
    {
	$span= $ant_token." ".$span;
	$pursue = 1;
    }
    elsif ($sentence->{tokens}->{$ant_token}->{ppos} eq "POS")
    {
	my $provisional = $ant_token;
	$ant_token = $token - 1;
	if ($sentence->{tokens}->{$ant_token}->{ppos}=~/^N/)
	{
	    $span = $ant_token." ".$provisional." ".$span;
	    $pursue = 1;
	}
    }
    elsif ($sentence->{tokens}->{$ant_token}->{ppos} eq "DT")
    {
	$span = $ant_token." ".$span;
    }

    while ($pursue)
    {
	$pursue = 0;
	$ant_token = $ant_token - 1;
	if ($sentence->{tokens}->{$ant_token}->{ppos}=~/^N/)
	{
	    $span = $ant_token." ".$span;
	    $pursue = 1;
	}
	elsif ($sentence->{tokens}->{$ant_token}->{ppos} eq "DT")
	{
	    $span = $ant_token." ".$span;
	}
    }

    $pursue = 0;
    my $next_token = $token + 1;
    
    if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/)
    {
	$span= $span." ".$next_token;
	$pursue = 1;
    }

    while ($pursue)
    {
	$pursue = 0;
	$next_token = $next_token + 1;
	if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/)
	{
	    $span= $span." ".$next_token;
	    $pursue = 1;
	}
    }

    return $span;
}




sub acceptChain
{
    my $automata = $_[0];
    my $final_state = $_[1];
    my $token = $_[2];
    my $sentence = $_[3];
    my $signal = $_[4];

    my $possible_signal;
    my $plausible = 1;
    my $actual_state = 0;

    while ($plausible)
    {
	$token = $token + 1;
	my $pos = $sentence->{tokens}->{$token}->{ppos};

	$pos=~s/\$/DOLLAR/;
    
	$plausible = 0;
	my $next_state;
	foreach my $state (keys %{ $automata->{$actual_state} })
	{
	    my $transition = $automata->{$actual_state}->{$state};
	    $transition=~s/\$/DOLLAR/;
	    if ($pos=~/^$transition/)
	    {
		$next_state = $state;
	    }
	}
	
	if ($next_state ne "")
	{
	    if ($possible_signal eq "")
	    {
		$possible_signal = $token;	
	    }
	    else
	    {
		$possible_signal = $possible_signal." ".$token;	
	    }
	    $plausible = 1;
	
	    if ($final_state->{$next_state})
	    {
		$signal = $possible_signal;
	    }
	
	    $actual_state = $next_state;
	}
    }

    return $signal;
}



sub automataIN
{
    my $token = $_[0];
    my $sentence = $_[1];

    my $automata;
    $automata->{"0"}->{"1"} = "DT";
    $automata->{"0"}->{"2"} = "JJ";
    $automata->{"0"}->{"3"} = "CD";
    $automata->{"0"}->{"4"} = "PRP\$";
    $automata->{"0"}->{"5"} = "NN";
    $automata->{"1"}->{"2"} = "JJ";
    $automata->{"1"}->{"3"} = "CD";
    $automata->{"1"}->{"5"} = "NN";
    $automata->{"2"}->{"2"} = "JJ";
    $automata->{"2"}->{"3"} = "CD";
    $automata->{"2"}->{"5"} = "NN";
    $automata->{"3"}->{"2"} = "JJ";
    $automata->{"3"}->{"3"} = "CD";
    $automata->{"3"}->{"5"} = "NN";
    $automata->{"4"}->{"2"} = "JJ";
    $automata->{"4"}->{"3"} = "CD";
    $automata->{"4"}->{"5"} = "NN";
    $automata->{"5"}->{"5"} = "NN";
    $automata->{"5"}->{"0"} = "CC";
    
    my $final_state;
    $final_state->{"5"} = 1;

    my $token_pos = $sentence->{tokens}->{$token}->{ppos};
    my $signal;

    my $next_token = $token;

    $signal = &acceptChain($automata,$final_state,$next_token,$sentence,$signal);

    if ($signal eq "")
    {
	$signal = $token;
    }

    return  $signal;
}




sub spanDT
{
    my $token = $_[0];
    my $sentence = $_[1];
    
    my $span = $token;
    
    my $pursue = 0;
    my $next_token = $token + 1;
    
    if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^JJ/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^DT/)
    {
	$span = $span." ".$next_token;
	$pursue=1;
    }

    while ($pursue)
    {
	$pursue = 0;
	$next_token = $next_token + 1;
	if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^JJ/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^DT/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^DT/)
	{
	    $span= $span." ".$next_token;
	    $pursue = 1;
	}
	elsif ($sentence->{tokens}->{$next_token}->{ppos} eq "POS")
	{
	    my $provisional = $next_token;
	    $next_token = $next_token + 1;
	    if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/)
	    {
		$span = $span." ".$provisional." ".$next_token;
		$pursue = 1;
	    }
	}
    }

    return $span;
}





sub spanCD
{
    my $token = $_[0];
    my $sentence = $_[1];
    
    my $span = $token;

    my $pursue = 0;
    my $ant_token = $token - 1;

    if ($sentence->{tokens}->{$ant_token}->{ppos}=~/^CD/ || $sentence->{tokens}->{$ant_token}->{ppos} eq "\$")
    {
	$span = $ant_token." ".$span;
	$pursue = 1;
    }
    elsif ($sentence->{tokens}->{$ant_token}->{ppos} eq "DT")
    {
	$span = $ant_token." ".$span;
    }

    while ($pursue)
    {
	$pursue = 0;
	$ant_token = $ant_token - 1;
	if ($sentence->{tokens}->{$ant_token}->{ppos}=~/^CD/ || $sentence->{tokens}->{$ant_token}->{ppos} eq "\$")
	{
	    $span = $ant_token." ".$span;
	    $pursue = 1;
	}
	elsif ($sentence->{tokens}->{$ant_token}->{ppos} eq "DT")
	{
	    $span = $ant_token." ".$span;
	}
    }

    $pursue = 0;
    my $next_token = $token + 1;
    
    if ($sentence->{tokens}->{$next_token}->{ppos}=~/^CD/ || $sentence->{tokens}->{$next_token}->{ppos} eq "\$")
    {
	$span = $span." ".$next_token;
	$pursue = 1;
    }

    while ($pursue)
    {
	$pursue = 0;
	$next_token = $next_token + 1;
	if ($sentence->{tokens}->{$next_token}->{ppos}=~/^CD/ || $sentence->{tokens}->{$next_token}->{ppos} eq "\$")
	{
	    $span = $span." ".$next_token;
	    $pursue = 1;
	}
    }


    return $span;
}


sub spanRBS
{
    my $token = $_[0];
    my $sentence = $_[1];

    my $span = $token;

    my $pursue = 0;
    my $next_token = $token + 1;

    if ($sentence->{tokens}->{$next_token}->{ppos} eq "IN")
    {
	my $provisional = $next_token;
	$next_token = $next_token + 1;
	if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/ || $sentence->{tokens}->{$next_token}->{ppos} eq "DT")
	{
	    $span = $span." ".$provisional." ".$next_token;
	    $pursue = 1;
	}
    }

    while ($pursue)
    {
	$pursue = 0;
	$next_token = $next_token + 1;
	if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^JJ/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^DT/ || $sentence->{tokens}->{$next_token}->{ppos}=~/^CC/)
	{
	    $span= $span." ".$next_token;
	    $pursue = 1;
	}
	elsif ($sentence->{tokens}->{$next_token}->{ppos} eq "POS")
	{
	    my $provisional = $next_token;
	    $next_token = $next_token + 1;
	    if ($sentence->{tokens}->{$next_token}->{ppos}=~/^N/)
	    {
		$span = $span." ".$provisional." ".$next_token;
		$pursue = 1;
	    }
	}
    }

    return $span;
}



1;
